/// IMPORTING THIRD PARTY PACKAGES
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:provider/provider.dart';

/// IMPORTING LOCAL PACKAGES
import 'package:zwap_design_system/zwap_design_system.dart';

/// ProviderNotifier to handle the checkbox state
class ClassicCheckBoxState extends ChangeNotifier{

  /// The state value
  bool value;

  ClassicCheckBoxState({this.value = false});

  /// Handling the changing of this value
  void changeValue(bool newValue){
    this.value = newValue;
    notifyListeners();
  }

}

/// Custom widget to render a circle checkbox
class ClassicCheckBox extends StatelessWidget {

  /// The label text as widget inside this classic checkbox component
  final BaseText labelText;

  ClassicCheckBox({Key? key,
    required this.labelText
  }): super(key: key);

  @override
  Widget build(BuildContext context) {
    return Consumer<ClassicCheckBoxState>(
      builder: (builder, provider, child){
        return CheckboxListTile(
          value: provider.value,
          onChanged: (dynamic newValue) => provider.changeValue(newValue),
          title: this.labelText,
        );
      }
    );
  }

}